
Core - Task # 53744

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Bug # 52949 (Resolved): Speed decrease since 4.5

Status: Resolved Priority: Should have
Author: Thomas Maroschik Category: Caching
Created: 2013-11-18 Assigned To: Thomas Maroschik
Updated: 2013-11-22 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: hard
Sprint Focus:
Subject: Change ClassLoader cache from proxy require files to standard cache backends
Description

Related issues:
related to Core - Bug # 53556: classLoader->loadClass calls requireOnce twice... Closed 2013-11-12

Associated revisions
Revision 51e23eda - 2013-11-22 15:24 - Thomas Maroschik

[TASK] Replace ClassLoader cache with standard caches

The class loader can now use all available cache backends
for retrieval of class loading information.

Using it with APC for example brings a good performance
boost.

Resolves: #53744
Releases: 6.2
Change-Id: I55db9686fa2d5b6462b4cb56c452ad2e99e1d2e7
Reviewed-on: https://review.typo3.org/25489
Reviewed-by: Wouter Wolters
Reviewed-by: Markus Klein
Tested-by: Markus Klein
Reviewed-by: Alexander Opitz
Tested-by: Alexander Opitz
Reviewed-by: Thorsten Kahler
Tested-by: Thorsten Kahler

History
#1 - 2013-11-18 20:55 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489
#2 - 2013-11-18 21:20 - Markus Klein
- Category set to Caching
- Target version set to next-patchlevel
- Complexity set to hard

#3 - 2013-11-18 21:44 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#4 - 2013-11-18 21:54 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#5 - 2013-11-19 00:07 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#6 - 2013-11-19 00:45 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#7 - 2013-11-19 00:48 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#8 - 2013-11-19 01:25 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#9 - 2013-11-19 08:23 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25489

#10 - 2013-11-22 15:30 - Thomas Maroschik
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:51e23edaf7d518e05293874ac4b631db77594da9.
#11 - 2013-11-22 15:31 - Thorsten Kahler

Performance tested on Ubuntu 12.04 (PHP 5.3.10) without bytecode cache:

Test scenario

    -  2 request to start page of (upgraded) introduction package 
    -  cache completely empty before
    -  Apache restarted before requests
    -  no PHP bytecode cache

    -  additional test: concurrent uncached requests

test environment on Github

before change
ab -n 2  http://typo3-workspace-test-environment.dev/

min max
497 4775
675 4098
570 3925
539 4346
528 4210
ab -n 30 -c 3  http://typo3-workspace-test-environment.dev/?no_cache=1

min median max
1071 2523 11678
2183 2431 14882
2185 2476 14779
2267 2531 14710
2272 2481 15044

after change
ab -n 2  http://typo3-workspace-test-environment.dev/

min max
559 2878
488 3229
470 2930
463 2904
529 2752
ab -n 30 -c 3  http://typo3-workspace-test-environment.dev/?no_cache=1

min median max
1026 2428 12555
1331 2286 14088
1879 2432 11427
2115 2361 10407
2108 2356 10440
